clear all;
clc

%%% Conversion rgb image into gray scale one and resize it 
[X,map] = imread('bitmap_format.bmp');
newmap = rgb2gray(map);
%imshow(X,newmap)

bw = imbinarize(X); % function to convert the grayscale image into a binary image
bw = bwareaopen(bw,50); % Remove background noise from the image with the bwareaopen function.
X2= imresize(bw,[1890 1890]);

imshow(X2)

imwrite(X2,'binary.bmp')


I=imread('binary.bmp');
imshow(I)

% obtain the boundary
[B,L] = bwboundaries(I,'noholes');

% obtain contour of each polygon
 for k = 1:length(B) 
   contour = B{k};
    
     [y,x]=find(I>0);

   % get the circle
      [cx,cy,r]=find_inner_circle(contour(:,2), contour(:,1));
      
   % plot
      theta = [linspace(0,2*pi) 0];
      hold on, plot(x,y, 'g.', 'MarkerSize',0.8);
      hold on, plot(cos(theta)*r+cx,sin(theta)*r+cy,'r', 'LineWidth', 2);
      hold on
      % getting coordinates of each polygon P(x,y)
      x_y_coordinates(k,:)=[round(cx*0.2645,2); round((1890-cy)*0.2645,2)];
      

 end
   
 %%% sorting MIC results to TCP achievable ones
 
 x_coor=x_y_coordinates(:,1).'; 
 y_coor=x_y_coordinates(:,2).';
 number_of_objects=length(B);
 j=1; % counter initialization
         for i=1:number_of_objects
             if (x_coor(1,i)<50) && (y_coor(1,i)<33)
                 x_c(1,j)=x_coor(1,i);
                 y_c(1,j)=y_coor(1,i);
                 j=j+1;
             end
         end
         
 
 
 %%% Socket connection of UR3 and Matlab
Robot_IP = '192.168.12.50'; %Enter Robot IP
robot = tcpip(Robot_IP,30003,'NetworkRole','server');
fclose(robot);

disp('Press Play on Robot...')
fopen(robot);
disp('Connected to Robot!');
disp('Ready...?, YES/NO')
ready = input('Ready to start? (y/n): ','s');
C=1;
if strcmp(ready,'y')
  disp(ready)
else
    C=0;
    fprintf(robot,'(0)');
    fclose(robot);
    disp('The Socket is closed! Restart program!')
end

%%% Sending number of objects and x, y coordinates to UR3

j=j-1; %  number of objects below 35
n=num2str(j); 
fprintf(robot,'%s\n',['(',n,')']);
k=1; % counter initialization

while (k<j)
    
  
   x=num2str(x_c(k)); 
  
   fprintf(robot,'%s\n',['(',x,')']);
   
 

   y=num2str(y_c(k));
   fprintf(robot,'%s\n', ['(',y,')']);
    k=k+1;
    
    
end

 
 
% given a polygon [x,y] find the inner circle [cx,cy,r]
function [cx,cy,r]=find_inner_circle(x,y)


% make a voronoi diagram
[vx,vy]=voronoi(x,y);

% find voronoi nodes inside the polygon [x,y]
Vx=vx(:);
Vy=vy(:);
% Here, you could also use a faster version of inpolygon
IN=inpolygon(Vx,Vy, x,y);
ind=find(IN==1);
Vx=Vx(ind);
Vy=Vy(ind);

% maximize the distance of each voronoi node to the closest node on the
% polygon.
minDist=0;
minDistInd=-1;
for i=1:length(Vx)
    dx=(Vx(i)-x);
    dy=(Vy(i)-y);
    r=min(dx.*dx+dy.*dy);
    if (r>minDist)
        minDist=r;
        minDistInd=i;
    end
end

% take the center and radius
cx=Vx(minDistInd);
cy=Vy(minDistInd);
r=sqrt(minDist);

end





